TITLE primo.asm: Risoluzione eserizio 1

COMMENT * Questo file contiene un programma che somma e visualizza 
il contenuto degli elementi presenti nel vettore A (vettore dichiarato e inizializzato nel programma).
*

	
;
STACK SEGMENT STACK 'STACK'    ; definizione del segmento di stack
      DB      64 DUP('STACK ') ; lo stack e' riempito con la stringa 'stack '
                               ; per identificarlo meglio in fase di debug
STACK ENDS                     
;



DATA SEGMENT PUBLIC 'DATA'     ; definizione segmento dati
  vett     DW 5,10,15,20       ; vettore di input
  lung	   DW 4		       ; numero degli elementi del vettore vett
  str      DB 'Somma elementi del vettore = ','$'
DATA ENDS



LENGTH	EQU 30			; lunghezza della stringa ascii_str1

CR 	EQU 13          	; carriage return
LF 	EQU 10                  ; line feed
SPAZIO	EQU 20h			; codifica ASCII del carattere 'spazio'
PRIMO	EQU 48			; codifica ASCII del carattere "0"

DISPLAY_CHAR EQU 2		; codice funzione per visualizzare carattere (in DL)
DISPLAY_STRING EQU 9		; codice funzione per visualizzare stringa (in DS:DX)
IN_CHAR	EQU 1			; codice funzione per input carattere (in AL)


CSEG SEGMENT PUBLIC 'CODE'
ES1   PROC FAR
      ASSUME CS:CSEG,DS:DATA,SS:STACK

Main:   PUSH DS               ; salvataggio valore corrente di DS 
        SUB AX,AX             ; AX viene azzerato, e
        PUSH AX               ; posto nello stack 
                              ; Quando con la RET si restituisce il
                              ; controllo al DOS, questo riparte da DS:0000. 
                              ; La RET effettua automaticamente il POP 
                              ; dei due registri

        MOV AX,SEG DATA       ; necessari 2 trasferimenti per assegnare a DS 
        MOV DS,AX             ; l'indirizzo del segmento dati in modo esplicito

	lea DX,str	      ; visualizza stringa
	CALL PutString

	MOV AX,0	      ; somma parziale = 0
	LEA SI,vett
	MOV CX,lung	      ; inizializza contatore elementi array
	JCXZ esci0
loops:	ADD AX,[SI]	      ; calcola la somma in AX
	ADD SI,2
	LOOP loops

esci0:  CALL PutNum	      ; Stampa la somma ed esce
        RET                   
ES1   ENDP



;; INIZIO PROCEDURE                   


; procedura InChar per l'acquisizione di un carattere da tastiera
InChar		PROC NEAR
		MOV AH, IN_CHAR
		INT 21H  	; AL riceve il carattere da tastiera
		RET
InChar		ENDP


; procedura PutChar per la visualizzazione di un carattere a video
PutChar		PROC NEAR
		MOV AH, DISPLAY_CHAR
		INT 21H  	; DL contiene il carattere da visualizzare
		RET
PutChar		ENDP


; procedura PutString per la visualizzazione di una stringa a video
PutString	PROC NEAR
		MOV AH, DISPLAY_STRING
		INT 21H  	; DS:DX contengono puntatore a stringa da visualizzare
		RET
PutString	ENDP


; procedura PutNum per la visualizzazione di un numero intero positivo (a 16 bit, contenuto in AX)
;        NB: effettua una serie di divisioni succesive per 10
;            utilizza lo stack per stampare le cifre in ordine inverso a come sono generate
PutNum		PROC NEAR
		MOV DX, 0	; DX-AX contiene il numero a 32 bit
		MOV CX, 0	; contatore delle cifre salvate
		MOV BX, 10
looppn:		DIV BX		; divido il numero per 10
		PUSH DX		; salvo il resto nello stack
		INC CX
		CMP AX,0
		JZ looppn2	; se quoziente nullo esco dal ciclo
		MOV DX,0	; il quoziente in DX-AX
		JMP looppn
looppn2:	POP DX		; successiva cifra da stampare (contenuta in DL)
		ADD DL, PRIMO	; i numeri vengono stampati dal pi significativo al meno
		PUSH CX		; salva ci che non pu essere modificato
		CALL PutChar	; ovvero in ordine inverso a quello di generazione
		POP CX
		loop looppn2
		RET
PutNum		ENDP

;; FINE PROCEDURE


CSEG ENDS

END Main    

