TITLE es2.asm: programma che risolve esercizio 2

COMMENT * Programma che legge tre numeri interi e stampa la somma dei due maggiori.
*

	
;
STACK SEGMENT STACK 'STACK'    ; definizione del segmento di stack
      DB      64 DUP('STACK ') ; lo stack e' riempito con la stringa 'stack '
                               ; per identificarlo meglio in fase di debug
STACK ENDS                     
;



DATA SEGMENT PUBLIC 'DATA'     ; definizione segmento dati
  strn1     DB 'Inserisci il primo numero',LF,CR,'$' 
  strn2     DB 'Inserisci il secondo numero',LF,CR,'$'
  strn3     DB 'Inserisci il terzo numero',LF,CR,'$'
  strs      DB 'Somma dei due maggiori = ','$'

  numeri    DW ?,?,?            ; array dei tre numeri inseriti

DATA ENDS



LENGTH	EQU 30			; lunghezza della stringa ascii_str1

CR 	EQU 13          	; carriage return
LF 	EQU 10                  ; line feed
SPAZIO	EQU 20h			; codifica ASCII del carattere 'spazio'
PRIMO	EQU 48			; codifica ASCII del carattere "0"

DISPLAY_CHAR EQU 2		; codice funzione per visualizzare carattere (in DL)
DISPLAY_STRING EQU 9		; codice funzione per visualizzare stringa (in DS:DX)
IN_CHAR	EQU 1			; codice funzione per input carattere (in AL)


CSEG SEGMENT PUBLIC 'CODE'
ES2   PROC FAR
      ASSUME CS:CSEG,DS:DATA,SS:STACK

Main:   PUSH DS               ; salvataggio valore corrente di DS 
        SUB AX,AX             ; AX viene azzerato, e
        PUSH AX               ; posto nello stack 
                              ; Quando con la RET si restituisce il
                              ; controllo al DOS, questo riparte da DS:0000. 
                              ; La RET effettua automaticamente il POP 
                              ; dei due registri

        MOV AX,SEG DATA       ; necessari 2 trasferimenti per assegnare a DS 
        MOV DS,AX             ; l'indirizzo del segmento dati in modo esplicito


	LEA DX, strn1	      ; stampa stringa
	CALL PutString
	CALL InNum	      ; acquisisce primo numero
	MOV numeri, AX	      ; memorizza primo numero in memoria
	MOV DL,LF	      ; va a capo
	Call PutChar
	MOV DL,CR
	Call PutChar

	LEA DX, strn2	      ; stampa stringa
	CALL PutString
	CALL InNum	      ; acquisisce numero
	MOV numeri+2, AX      ; memorizza numero in memoria
	MOV DL,LF	      ; va a capo
	Call PutChar
	MOV DL,CR
	Call PutChar

	LEA DX, strn3	      ; stampa stringa
	CALL PutString
	CALL InNum	      ; acquisisce numero
	MOV numeri+4, AX      ; memorizza numero in memoria
	MOV DL,LF	      ; va a capo
	Call PutChar
	MOV DL,CR
	Call PutChar

	LEA DX, strs	      ; stampa stringa
	CALL PutString
	MOV AX,numeri	      ; calcola la somma in AX
	MOV BX,numeri+2
	CMP AX,BX
	JA saltsc
	XCHG AX,BX
saltsc: CMP BX,numeri+4
	JB salt2
	ADD AX,BX
	JMP stampsom
salt2:  ADD AX,numeri+4	
stampsom: CALL PutNum	      ; stampa la somma e ritorna
          RET  

ES2 ENDP



;; INIZIO PROCEDURE                   


; procedura InChar per l'acquisizione di un carattere da tastiera
InChar		PROC NEAR
		MOV AH, IN_CHAR
		INT 21H  	; AL riceve il carattere da tastiera
		RET
InChar		ENDP


; procedura InNum per l'acquisizione di un numero a 16 bit da tastiera
; (il numero  restituito in AX)
; NB: non effettua alcun controllo sull'input,  se i caratteri immessi
;     non corrispondono ad un numero il valore restituito  indefinito
InNum		PROC NEAR
		MOV AX,0	; inizializza AX a 0		
 lopinn:	PUSH AX
		CALL InChar	; acquisisce carattere
		MOV BL,AL	; e lo salva in BL
		POP AX
		CMP BL,CR	; se CR termina acquisizione
		JE esclopinn
		MOV DX,10	; AX=AX*10
		MUL DX
		SUB BL,PRIMO	; AX=AX+cifra
		MOV BH,0
		ADD AX,BX
		JMP lopinn
 esclopinn:	RET			
InNum		ENDP


; procedura PutChar per la visualizzazione di un carattere a video
PutChar		PROC NEAR
		MOV AH, DISPLAY_CHAR
		INT 21H  	; DL contiene il carattere da visualizzare
		RET
PutChar		ENDP


; procedura PutString per la visualizzazione di una stringa a video
PutString	PROC NEAR
		MOV AH, DISPLAY_STRING
		INT 21H  	; DS:DX contengono puntatore a stringa da visualizzare
		RET
PutString	ENDP


; procedura PutNum per la visualizzazione di un numero intero positivo (a 16 bit, contenuto in AX)
;        NB: effettua una serie di divisioni succesive per 10
;            utilizza lo stack per stampare le cifre in ordine inverso a come sono generate
PutNum		PROC NEAR
		MOV DX, 0	; DX-AX contiene il numero a 32 bit
		MOV CX, 0	; contatore delle cifre salvate
		MOV BX, 10
looppn:		DIV BX		; divido il numero per 10
		PUSH DX		; salvo il resto nello stack
		INC CX
		CMP AX,0
		JZ looppn2	; se quoziente nullo esco dal ciclo
		MOV DX,0	; il quoziente in DX-AX
		JMP looppn
looppn2:	POP DX		; successiva cifra da stampare (contenuta in DL)
		ADD DL, PRIMO	; i numeri vengono stampati dal pi significativo al meno
		PUSH CX		; salva ci che non pu essere modificato
		CALL PutChar	; ovvero in ordine inverso a quello di generazione
		POP CX
		loop looppn2
		RET
PutNum		ENDP


;; FINE PROCEDURE


CSEG ENDS

END Main    

