TITLE es3.asm: risoluzione esercizio 3

COMMENT * Questo file stampa i primi 100 numeri primi rispettando le modalit indicate nell'esempio
*

	
;
STACK SEGMENT STACK 'STACK'    ; definizione del segmento di stack
      DB      64 DUP('STACK ') ; lo stack e' riempito con la stringa 'stack '
                               ; per identificarlo meglio in fase di debug
STACK ENDS                     
;



DATA SEGMENT PUBLIC 'DATA'     ; definizione segmento dati
  str0     DB 'Programma di prova InChar, PutChar, PutString e PutNum',LF,CR,'Inserisci un carattere',LF,CR,'$' 
  str1     DB 'Adesso visualizzo i numeri 1234 e 12345',LF,CR,'$'
DATA ENDS



LENGTH	EQU 30			; lunghezza della stringa ascii_str1

CR 	EQU 13          	; carriage return
LF 	EQU 10                  ; line feed
PRIMO	EQU 48			; codifica ASCII del carattere "0"

DISPLAY_CHAR EQU 2		; codice funzione per visualizzare carattere (in DL)
DISPLAY_STRING EQU 9		; codice funzione per visualizzare stringa (in DS:DX)



CSEG SEGMENT PUBLIC 'CODE'
LABOR PROC FAR
      ASSUME CS:CSEG,DS:DATA,SS:STACK

Main:   PUSH DS               ; salvataggio valore corrente di DS 
        SUB AX,AX             ; AX viene azzerato, e
        PUSH AX               ; posto nello stack 
                              ; Quando con la RET si restituisce il
                              ; controllo al DOS, questo riparte da DS:0000. 
                              ; La RET effettua automaticamente il POP 
                              ; dei due registri

        MOV AX,SEG DATA       ; necessari 2 trasferimenti per assegnare a DS 
        MOV DS,AX             ; l'indirizzo del segmento dati in modo esplicito


	MOV CX,100	      ; numero di numeri primi da stampare
	MOV BX,1	      ; inizializza intero corrente
loopm:	PUSH CX		      ; controlla se BX  primo
	PUSH BX
	CALL NPrimo
	POP BX
	POP CX
	CMP AL,1	      ; se non  primo continua il ciclo senza decrementare CX
	JE  prlpm
	INC BX		      ; incrementa intero corrente
	JMP loopm
prlpm:	MOV AX,BX	      ; se  primo stampa il numero corrente
	PUSH CX
	PUSH BX
	CALL PutNum
	MOV DL,LF
	CALL PutChar
	MOV DL,CR
	CALL Putchar
	POP BX
	POP CX
        INC BX		      ; incrementa intero corrente
	loop loopm	      ; decrementa CX e continua il loop se maggiore di 0

       RET                    ; si restituisce il controllo al DOS
LABOR ENDP


; riceve in ingresso in BX un numero a 16 bit
; restituisce in AL 1 se primo, 0 se non lo 
NPrimo		PROC NEAR
		MOV CX,2      ; CX va da 2 a numero-1
lppr:		CMP CX,BX     ; se CX = numero allora  primo
		JAE  isprimo
		MOV DX,0      ; DX=resto di numero/CX
		MOV AX,BX
		DIV CX
		CMP DX,0      ; se resto a 0 allora non  primo
		JE noprimo
		INC CX	      ; altrimenti incrementa Cx e continua il loop	
		JMP lppr
isprimo:	MOV AL,1
		RET
noprimo:	MOV AL,0
		RET
NPrimo		ENDP


;; INIZIO PROCEDURE                   



; procedura PutChar per la visualizzazione di un carattere a video
PutChar		PROC NEAR
		MOV AH, DISPLAY_CHAR
		INT 21H  	; DL contiene il carattere da visualizzare
		RET
PutChar		ENDP


; procedura PutString per la visualizzazione di una stringa a video
PutString	PROC NEAR
		MOV AH, DISPLAY_STRING
		INT 21H  	; DS:DX contengono puntatore a stringa da visualizzare
		RET
PutString	ENDP


; procedura PutNum per la visualizzazione di un numero intero positivo (a 16 bit, contenuto in AX)
;        NB: effettua una serie di divisioni succesive per 10
;            utilizza lo stack per stampare le cifre in ordine inverso a come sono generate
PutNum		PROC NEAR
		MOV DX, 0	; DX-AX contiene il numero a 32 bit
		MOV CX, 0	; contatore delle cifre salvate
		MOV BX, 10
looppn:		DIV BX		; divido il numero per 10
		PUSH DX		; salvo il resto nello stack
		INC CX
		CMP AX,0
		JZ looppn2	; se quoziente nullo esco dal ciclo
		MOV DX,0	; il quoziente in DX-AX
		JMP looppn
looppn2:	POP DX		; successiva cifra da stampare (contenuta in DL)
		ADD DL, PRIMO	; i numeri vengono stampati dal pi significativo al meno
		PUSH CX		; salva ci che non pu essere modificato
		CALL PutChar	; ovvero in ordine inverso a quello di generazione
		POP CX
		loop looppn2
		RET
PutNum		ENDP

;; FINE PROCEDURE


CSEG ENDS

END Main    

